/*
 * d2c
 *
 * Device to cloud API
 *
 * API version: 0.1
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package easyplatform

import (
	"encoding/json"
	"log"
	"net/http"
)

type fullRequest struct {
	Meta    *ApiAssistantRequestMeta    `json:"meta,omitempty"`
	Request *ApiAssistantRequestRequest `json:"request,omitempty"`
}

func AssistantRequest(w http.ResponseWriter, r *http.Request) {

	decoder := json.NewDecoder(r.Body)
	decoder.DisallowUnknownFields()

	request := &fullRequest{}
	err := decoder.Decode(request)
	if err != nil {
		if unmarshalErr, ok := err.(*json.UnmarshalTypeError); ok {
			log.Println("Wrong type provided for field %v" + unmarshalErr.Field)
		} else {
			log.Println("Bad request %v" + err.Error())
		}
	}
	log.Printf("Command: %v", request.Request.Command)

	var response = ApiAssistantResponse{
		Response: &ApiAssistantResponseResponse{
			Text:       "Хуйлопан",
			Tts:        "Хуйлопан",
			EndSession: false,
		},
		Version: "1.0",
	}
	js, err := json.Marshal(response)
	if err != nil {
		http.Error(w, err.Error(), http.StatusInternalServerError)
		return
	}
	w.Header().Set("Content-Type", "application/json; charset=UTF-8")
	w.Write(js)
	w.WriteHeader(http.StatusOK)

}
